﻿using Syncfusion.EJ2.Base;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;

namespace dotnet_mvc_sample.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            var Order = OrdersDetails.GetAllRecords();
            ViewBag.DataSource = BigData.GetAllRecords();
            ViewBag.DataSource1 = Order;
            ViewBag.DataSource2 = OrdersData.GetAllRecords();
            return View();
        }
        [HttpPost]
        public ActionResult TodayPage()
        {
           // IEnumerable<TimeSheet> IE = JsonConvert.DeserializeObject<IEnumerable<TimeSheet>>(value, new JsonSerializerSettings
           // { Culture = new CultureInfo("vi-VN") });
           // DateTime SelectedDay = IE.ToList().First().Date;
          //  double TimeSpan = (SelectedDay - DateTime.Today).Days / 7;
           // double CurrentPage = lastpage - Math.Floor(TimeSpan);
            var jsontext = new { actPage = 4, actDay = 3 };
            return Json(jsontext, JsonRequestBehavior.AllowGet);
        }
        public ActionResult UrlDatasourceDd1(DataManagerRequest dm)
        {
            IEnumerable<OrdersData> DataSource = OrdersData.GetAllRecords();
            DataOperations operation = new DataOperations();

            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                //DataSource = operation.PerformFiltering(DataSource, dm.Where, dm.Where[0].Operator);
                if (dm.Where != null)
                {
                    DataSource = (from cust in DataSource
                                  where cust.ShipName.ToLower().StartsWith(dm.Where[0].predicates[0].value.ToString())
                            select cust).ToList();
                }
            }
            if (dm.Skip != 0)
            {
                DataSource = operation.PerformSkip(DataSource, dm.Skip);   //Paging
            }
            if (dm.Take != 0)
            {
                DataSource = operation.PerformTake(DataSource, dm.Take);
            }
            return Json(DataSource);
        }
        public ActionResult ForeignKeyData(TestDm dm)
        {

            IEnumerable DataSource = OrdersData.GetAllRecords().ToList();
            DataOperations operation = new DataOperations();

            if (dm.Search != null && dm.Search.Count > 0)
            {
                DataSource = operation.PerformSearching(DataSource, dm.Search);  //Search
            }
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                DataSource = operation.PerformSorting(DataSource, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                DataSource = operation.PerformFiltering(DataSource, dm.Where, dm.Where[0].Operator);
            }
            int count = DataSource.Cast<OrdersData>().Count();
            if (dm.Skip != 0)
            {
                DataSource = operation.PerformSkip(DataSource, dm.Skip);   //Paging
            }
            if (dm.Take != 0)
            {
                DataSource = operation.PerformTake(DataSource, dm.Take);
            }
            return dm.RequiresCounts ? Json(new { result = DataSource, count = count }) : Json(DataSource);
        }
        public ActionResult UrlDatasource(DataManagerRequest dm)
        {

            IEnumerable DataSource = OrdersDetails.GetAllRecords().ToList();
            DataOperations operation = new DataOperations();

            if (dm.Search != null && dm.Search.Count > 0)
            {
                DataSource = operation.PerformSearching(DataSource, dm.Search);  //Search
            }
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                DataSource = operation.PerformSorting(DataSource, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                DataSource = operation.PerformFiltering(DataSource, dm.Where, dm.Where[0].Operator);
            }
            int count = DataSource.Cast<OrdersDetails>().Count();
            if (dm.Skip != 0)
            {
                DataSource = operation.PerformSkip(DataSource, dm.Skip);   //Paging
            }
            if (dm.Take != 0)
            {
                DataSource = operation.PerformTake(DataSource, dm.Take);
            }
            return dm.RequiresCounts ? Json(new { result = DataSource, count = count }) : Json(DataSource);
        }

        public ActionResult Update(CRUDModel<OrdersDetails> myObject)
        {
            var ord = myObject;
            OrdersDetails val = OrdersDetails.GetAllRecords().Where(or => or.GetType().GetProperty(myObject.KeyColumn).GetValue(or).ToString() == myObject.Key.ToString()).FirstOrDefault();
            
            try
            {
                if (val.OrderID %2 == 0)
                {
                    return new HttpStatusCodeResult(HttpStatusCode.BadRequest, "Falta asignar los ingredientes de la comida");
                }
                else
                {
                    if (val != null)
                    {
                        val.OrderID = ord.Value.OrderID;
                        val.EmployeeID = ord.Value.EmployeeID;
                        val.CustomerID = ord.Value.CustomerID;
                        val.Freight = ord.Value.Freight;
                        val.OrderDate = ord.Value.OrderDate;
                        val.ShipCity = ord.Value.ShipCity;
                        val.ShipAddress = ord.Value.ShipAddress;
                        val.ShippedDate = ord.Value.ShippedDate;
                    }
                    return Json(ord.Value);

                }

            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }

        }
        public ActionResult Insert(OrdersDetails value)
        {
            var ord = value;

            try
            {
                if (ord.OrderID % 2 == 0)
                {
                    return new HttpStatusCodeResult(HttpStatusCode.BadRequest, "Falta asignar los ingredientes de la comida");
                }
                else
                {
                    OrdersDetails.GetAllRecords().Insert(0, ord);
                    return Json(value, JsonRequestBehavior.AllowGet);

                }

            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }            

        }
        public ActionResult Remove(int key)
        {
            try
            {
                if (key % 2 == 0)
                {
                    //throw new NullReferenceException("exception in delete");
                    return new HttpStatusCodeResult(HttpStatusCode.BadRequest, "Falta asignar los ingredientes de la comida");
                }
                else
                {

                    OrdersDetails.GetAllRecords().Remove(OrdersDetails.GetAllRecords().Where(or => or.OrderID == key).FirstOrDefault());
                    return new HttpStatusCodeResult(HttpStatusCode.BadRequest, "Falta asignar los ingredientes de la comida");
                }

            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
           
        }


        public class TestDm : DataManagerRequest
        {
            public int flag { get; set; }
        }

        public class CRUDModel
        {
            //public List<OrdersDetails> Added { get; set; }
            //public List<OrdersDetails> Changed { get; set; }
            //public List<OrdersDetails> Deleted { get; set; }
            public OrdersDetails value { get; set; }
            public int key { get; set; }
            public string action { get; set; }
            public string keycolumn { get; set; }
            public int IDMASTER { get; set; }
        }
        public class OrdersDetails
        {
            public static List<OrdersDetails> order = new List<OrdersDetails>();
            public OrdersDetails()
            {

            }
            public OrdersDetails(int OrderID, string CustomerId, int EmployeeId, double Freight, bool Verified, DateTime OrderDate, string ShipCity, string ShipName, string ShipCountry, DateTime ShippedDate, string ShipAddress)
            {
                this.OrderID = OrderID;
                this.CustomerID = CustomerId;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.ShipCity = ShipCity;
                this.Verified = Verified;
                this.OrderDate = OrderDate;
                this.ShipName = ShipName;
                this.ShipCountry = ShipCountry;
                this.ShippedDate = ShippedDate;
                this.ShipAddress = ShipAddress;
            }
            public static List<OrdersDetails> GetAllRecords()
            {
                if (order.Count() == 0)
                {
                    int code = 10000;
                    int cd = 10;
                    for (int i = 1; i < 5; i++)
                    {
                        order.Add(new OrdersDetails(code + 1, "ALFKI", cd + 1, 2.3 * i, false, new DateTime(1991, 05, 15), "Berlin", "Simons bistro", "Denmark", new DateTime(1996, 7, 16), "Kirchgasse 6"));
                        order.Add(new OrdersDetails(code + 2, "ANATR", cd + 2, 3.3 * i, true, new DateTime(1990, 04, 04), "Madrid", "Queen Cozinha", "Brazil", new DateTime(1996, 9, 11), "Avda. Azteca 123"));
                        order.Add(new OrdersDetails(code + 3, "ANTON", cd + 3, 4.3 * i, true, new DateTime(1957, 11, 30), "Cholchester", "Frankenversand", "Germany", new DateTime(1996, 10, 7), "Carrera 52 con Ave. Bolívar #65-98 Llano Largo"));
                        order.Add(new OrdersDetails(code + 4, "BLONP", cd + 4, 5.3 * i, false, new DateTime(1930, 10, 22), "Marseille", "Ernst Handel", "Austria", new DateTime(1996, 12, 30), "Magazinweg 7"));
                        order.Add(new OrdersDetails(code + 5, "BOLID", cd + 5, 6.3 * i, true, new DateTime(1953, 02, 18), "Tsawassen", "Hanari Carnes", "Switzerland", new DateTime(1997, 12, 3), "1029 - 12th Ave. S."));
                        code += 5;
                        cd += 5;
                    }
                }
                return order;
            }

            public int? OrderID { get; set; }
            public string CustomerID { get; set; }
            public int? EmployeeID { get; set; }
            public double? Freight { get; set; }
            public string ShipCity { get; set; }
            public bool Verified { get; set; }
            public DateTime OrderDate { get; set; }

            public string ShipName { get; set; }

            public string ShipCountry { get; set; }

            public DateTime ShippedDate { get; set; }
            public string ShipAddress { get; set; }
        }

        public class OrdersData
        {
            public static List<OrdersData>
    order1 = new List<OrdersData>
        ();
            public OrdersData()
            {

            }
            public OrdersData(int UnitID, int N2, int N1, int EmployeeId, string ShipName, string ShipAddress)
            {
                this.UnitID = UnitID;
                this.N1 = N1;
                this.N2 = N2;
                this.EmployeeID = EmployeeId;
                this.ShipName = ShipName;
                this.ShipAddress = ShipAddress;
            }
            public static List<OrdersData>
                GetAllRecords()
            {
                if (order1.Count() == 0)
                {
                    int code = 10;
                    for (int i = 1; i < 2; i++)
                    {
                        order1.Add(new OrdersData(code + 1, 16, 11, code + 1, " Alizet" + i, "Zen. Jelivia 12"));
                        order1.Add(new OrdersData(code + 1, 10, 15, code + 2, " Cozinha" + i, "Avda. Azteca 123"));
                        order1.Add(new OrdersData(code + 2, 15, 29, code + 3, "Frankenversand" + i, "Carrera 52 con Ave. Bolívar #65-98 Llano Largo"));
                        order1.Add(new OrdersData(code + 3, 18, 30, code + 4, " Handel" + i, "Magazinweg 7"));
                        order1.Add(new OrdersData(code + 4, 22, 25, code + 5, " Carnes" + i, "1029 - 12th Ave. S."));
                        code += 5;
                    }
                }
                return order1;
            }
            public int? UnitID { get; set; }
            public int? EmployeeID { get; set; }

            public int? N1 { get; set; }
            public int? N2 { get; set; }

            public string ShipName { get; set; }
            public string ShipAddress { get; set; }
        }

        public class BigData
        {
            public static List<BigData> order = new List<BigData>();
            public BigData()
            {

            }
            public BigData(int OrderID, string CustomerId, int EmployeeId, double Freight, bool Verified, DateTime OrderDate, string ShipCity, string ShipName, string ShipCountry, DateTime ShippedDate, string ShipAddress)
            {
                this.OrderID = OrderID;
                this.CustomerID = CustomerId;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.ShipCity = ShipCity;
                this.Verified = Verified;
                this.OrderDate = OrderDate;
                this.ShipName = ShipName;
                this.ShipCountry = ShipCountry;
                this.ShippedDate = ShippedDate;
                this.ShipAddress = ShipAddress;
            }
            public static List<BigData> GetAllRecords()
            {
                if (order.Count() == 0)
                {
                    int code = 10000;
                    for (int i = 1; i < 8; i++)
                    {
                        order.Add(new BigData(code + 1, "ALFKI", i + 0, 2.3 * i, false, new DateTime(1991, 05, 15), "Berlin", "Simons bistro", "Denmark", new DateTime(1996, 7, 16), "Kirchgasse 6"));
                        order.Add(new BigData(code + 2, "ANATR", i + 2, 3.3 * i, true, new DateTime(1990, 04, 04), "Madrid", "Queen Cozinha", "Brazil", new DateTime(1996, 9, 11), "Avda. Azteca 123"));
                        order.Add(new BigData(code + 3, "ANTON", i + 1, 4.3 * i, true, new DateTime(1957, 11, 30), "Cholchester", "Frankenversand", "Germany", new DateTime(1996, 10, 7), "Carrera 52 con Ave. Bolívar #65-98 Llano Largo"));
                        order.Add(new BigData(code + 4, "BLONP", i + 3, 5.3 * i, false, new DateTime(1930, 10, 22), "Marseille", "Ernst Handel", "Austria", new DateTime(1996, 12, 30), "Magazinweg 7"));
                        order.Add(new BigData(code + 5, "BOLID", i + 4, 6.3 * i, true, new DateTime(1953, 02, 18), "Tsawassen", "Hanari Carnes", "Switzerland", new DateTime(1997, 12, 3), "1029 - 12th Ave. S."));
                        code += 5;
                    }
                }
                return order;
            }
            public int? OrderID { get; set; }
            public string CustomerID { get; set; }
            public int? EmployeeID { get; set; }
            public double? Freight { get; set; }
            public string ShipCity { get; set; }
            public bool Verified { get; set; }
            public DateTime OrderDate { get; set; }
            public string ShipName { get; set; }
            public string ShipCountry { get; set; }
            public DateTime ShippedDate { get; set; }
            public string ShipAddress { get; set; }
        }
        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}